import es
import random
import popuplib
import langlib
import playerlib
import usermsg
import gamethread
import vecmath
import os.path
import pickle
from configobj import ConfigObj
try:
    import colormsglib
    from colormsglib import ColorMsg
    colormsglib = colormsglib.info.version
except ImportError:
    colormsglib = 0

info = es.AddonInfo()
info.name = "Victim_Stats"
info.version = "2.0"
info.url = "http://forums.mattie.info/cs/forums/viewtopic.php?t=22063" ## Make sure to change this when uploading
info.author = "Satoon101"
es.ServerVar("victim_stats_version",info.version,"victim_stats_version").makepublic()

tools_version = es.ServerVar('est_version')
dict_vs = {}
dict_dest = {}
dict_stats = {}
counter = 0
anno_counter = 0
use_round_end = 0
vic_hitgroup = {1:'vichead',2:'vicchst',3:'vicstmc',4:'viclarm',5:'vicrarm',6:'viclleg',7:'vicrleg'}
wnd_hitgroup = {1:'wndhead',2:'wndchst',3:'wndstmc',4:'wndlarm',5:'wndrarm',6:'wndlleg',7:'wndrleg'}
hitgroups = {1:'Head',2:'Chest',3:'Stomach',4:'L Arm',5:'R Arm',6:'L Leg',7:'R Leg'}
vs_stats = {0:'Off',1:'Text: Hitboxes',2:'Text: No Hitboxes',3:'GUI: Hitboxes',4:'GUI: No Hitboxes'}
vs_dest = {0:'Off',1:'Kills/Bottom',2:'Damage/Bottom',3:'Kills/Center',4:'Damage/Center',5:'Kills/Both',6:'Damage/Both'}
vs_beam = {0:'Off',1:'Team Colors',2:'Random Colors',3:'Set Colors'}
vs_range = {1:1,2:1,3:10,4:10,5:100,6:100}
color_range = {1:'+ 1',2:'- 1',3:'+ 10',4:'- 10',5:'+ 100',6:'- 100',7:'Back'}

es.mexec('../addons/eventscripts/victim_stats/vs_config.cfg')
anno_rounds = es.ServerVar('anno_rounds')
anno_text = es.ServerVar('anno_text')
beam_ison = es.ServerVar('beam_ison')
beam_time = es.ServerVar('beam_time')
beam_vmt = es.ServerVar('beam_vmt')
beam_user = es.ServerVar('beam_user')
beam_user_blue = es.ServerVar('beam_user_blue')
beam_user_green = es.ServerVar('beam_user_green')
beam_user_red = es.ServerVar('beam_user_red')
beam_width = es.ServerVar('beam_width')
beam_without_tools = es.ServerVar('beam_without_tools')
dest_ison = es.ServerVar('dest_ison')
dest_user = es.ServerVar('dest_user')
stats_dist = es.ServerVar('stats_dist')
stats_ison = es.ServerVar('stats_ison')
stats_user = es.ServerVar('stats_user')
timeout_death = es.ServerVar('timeout_death')
timeout_round = es.ServerVar('timeout_round')
if colormsglib > 0:
    color_attacker = es.ServerVar('color_attacker')
    color_wounded = es.ServerVar('color_wounded')
    color_killed = es.ServerVar('color_killed')
    color_killer = es.ServerVar('color_killer')
else:
    color_attacker = '#lightgreen'
    color_wounded = '#lightgreen'
    color_killed = '#lightgreen'
    color_killer = '#lightgreen'

def load():
    global dict_vs
    es.dbgmsg(0,"[Victim Stats] Initialising Victim Stats")
    user_file = es.getAddonPath('victim_stats') + '/user_data.db'
    if os.path.isfile(user_file):
        file_users = open(user_file)
        dict_vs = pickle.load(file_users)
        file_users.close()

def player_activate(ev):
    global dict_vs, stats_user, dest_user, beam_user, user_color
    if ev['es_steamid'] != 'BOT':
        userid = ev['userid']
        vs_user = playerlib.uniqueid(userid, True)
        if not vs_user in dict_vs:
            dict_vs[vs_user] = {}
            dict_vs[vs_user]['stats'] = stats_user
            dict_vs[vs_user]['dest'] = dest_user
            dict_vs[vs_user]['beam'] = beam_user
            dict_vs[vs_user]['red'] = beam_user_red
            dict_vs[vs_user]['green'] = beam_user_green
            dict_vs[vs_user]['blue'] = beam_user_blue
            save_users()
        
def round_start(ev):
    global dict_dest, anno_counter, anno_rounds, anno_text, dict_stats
    dict_dest.clear()
    anno_counter += 1
    if anno_counter == anno_rounds and anno_rounds != 0:
        anno_counter = 0
        es.msg('#multi', '#green[Victim Stats]#default type #lightgreen%s#default for user options'%(anno_text))
    for user in playerlib.getPlayerList('#human'):
        vs_user = playerlib.uniqueid(user, True)
        dict_stats[vs_user] = {}
    
def player_hurt(ev):
    global dict_dest, dict_stats
    if ev['es_userteam'] != ev['es_attackerteam'] and ev['es_attackerteam'] in ('2','3'):
        userid = int(ev['userid'])
        attacker = int(ev['attacker'])
        dmg_health = int(ev['dmg_health'])
        vs_user = playerlib.uniqueid(userid, True)
        vs_attacker = playerlib.uniqueid(attacker, True)
        attackername = ev['es_attackername']
        username = ev['es_username']
        hitgroup = int(ev['hitgroup'])
        weapon = ev['weapon']
        if not vs_attacker in dict_dest:
            dict_dest[vs_attacker] = {}
            dict_dest[vs_attacker]['damage'] = 0
            dict_dest[vs_attacker]['kills'] = 0
            dict_dest[vs_attacker]['name'] = str(attackername)
        dict_dest[vs_attacker]['damage'] += int(dmg_health)
        if ev['es_steamid'] != 'BOT':
            if not vs_attacker in dict_stats[vs_user]:
                dict_stats[vs_user][vs_attacker] = {}
                for x in range(1,8):
                    group = vic_hitgroup[x]
                    dict_stats[vs_user][vs_attacker][group] = 0
                for x in range(1,8):
                    group = wnd_hitgroup[x]
                    dict_stats[vs_user][vs_attacker][group] = 0
                dict_stats[vs_user][vs_attacker]["wounded"] = 0
                dict_stats[vs_user][vs_attacker]["wndhits"] = 0
                dict_stats[vs_user][vs_attacker]["victim"] = 0
                dict_stats[vs_user][vs_attacker]["vichits"] = 0
                dict_stats[vs_user][vs_attacker]["oppname"] = attackername
                dict_stats[vs_user][vs_attacker]["killed"] = 0
                dict_stats[vs_user][vs_attacker]["weapon"] = ' '
                dict_stats[vs_user][vs_attacker]["distance"] = ' '
            dict_stats[vs_user][vs_attacker]["victim"] += dmg_health
            dict_stats[vs_user][vs_attacker]["vichits"] += 1
            if int(ev['hitgroup']) in vic_hitgroup:
                hitgroup = vic_hitgroup[int(ev['hitgroup'])]
            elif weapon in ('knife','hegrenade','flashbang','smokegrenade'):
                hitgroup = "vicchst"
            dict_stats[vs_user][vs_attacker][hitgroup] += 1
        if ev['es_attackersteamid'] != 'BOT':
            if not vs_user in dict_stats[vs_attacker]:
                dict_stats[vs_attacker][vs_user] = {}
                for x in range(1,8):
                    group = vic_hitgroup[x]
                    dict_stats[vs_attacker][vs_user][group] = 0
                for x in range(1,8):
                    group = wnd_hitgroup[x]
                    dict_stats[vs_attacker][vs_user][group] = 0
                dict_stats[vs_attacker][vs_user]["wounded"] = 0
                dict_stats[vs_attacker][vs_user]["wndhits"] = 0
                dict_stats[vs_attacker][vs_user]["victim"] = 0
                dict_stats[vs_attacker][vs_user]["vichits"] = 0
                dict_stats[vs_attacker][vs_user]["oppname"] = username
                dict_stats[vs_attacker][vs_user]["killed"] = 0
                dict_stats[vs_attacker][vs_user]["weapon"] = ' '
                dict_stats[vs_attacker][vs_user]["distance"] = ' '
            dict_stats[vs_attacker][vs_user]["wounded"] += dmg_health
            dict_stats[vs_attacker][vs_user]["wndhits"] += 1
            if int(ev['hitgroup']) in wnd_hitgroup:
                hitgroup = wnd_hitgroup[int(ev['hitgroup'])]
            elif weapon in ('knife','hegrenade','flashbang','smokegrenade'):
                hitgroup = "wndchst"
            dict_stats[vs_attacker][vs_user][hitgroup] += 1
        
def player_death(ev):
    global dict_vs, dict_dest, counter, stats_ison, beam_ison, beam_vmt, beam_time, beam_width, beam_without_tools, stats_dist, use_round_end, dict_stats
    use_round_end = 1
    health = ev['es_attackerhealth']
    weapon = ev['weapon']
    headshot = int(ev['headshot'])
    attacker = ev['attacker']
    vs_attacker = playerlib.uniqueid(attacker, True)
    user = ev['userid']
    vs_user = playerlib.uniqueid(user, True)
    attackername = ev['es_attackername']
    if not vs_attacker in dict_dest:
        dict_dest[vs_attacker] = {}
        dict_dest[vs_attacker]['damage'] = 0
        dict_dest[vs_attacker]['kills'] = 0
        dict_dest[vs_attacker]['name'] = str(attackername)
    if ev['es_userteam'] != ev['es_attackerteam'] and ev['es_attackerteam'] in ('2','3'):
        killer = 'Killer' if headshot == 0 else 'Killer HS'
        dict_dest[vs_attacker]['kills'] += 1
    if tools_version < '0.414' and beam_ison == 1:
        model_vmt = es.precachemodel(beam_vmt)
        user_loc = es.getplayerlocation(user)
        atta_loc = es.getplayerlocation(attacker)
        user_vec = es.createvectorstring(user_loc[0], user_loc[1], user_loc[2])
        atta_vec = es.createvectorstring(atta_loc[0], atta_loc[1], atta_loc[2] + 45.0)
        if beam_without_tools == 1:
            team = int(ev['es_attackerteam'])
            if team in [2,3]:
                red = 255 if team == 2 else 0
                green = 0
                blue = 255 if team == 3 else 0
        else:
            red = random.randint(1,255)
            green = random.randint(1,255)
            blue = random.randint(1,255)
        es.effect("beam", user_vec, atta_vec, model_vmt, model_vmt, 0, 0, beam_time, beam_width, beam_width, 0, 0, red, green, blue, 255, 0,)
    if ev['es_attackersteamid'] != 'BOT' or ev['es_steamid'] != 'BOT':
        if ev['es_steamid'] != 'BOT' and beam_ison == 1:
            user_x, user_y, user_z = es.getplayerlocation(user)
            atta_x, atta_y, atta_z = es.getplayerlocation(attacker)
            if tools_version >= '0.414':
                beam_user = int(dict_vs[vs_user]['beam'])
                if beam_user > 0:
                    if beam_user == 1:
                        team = int(ev['es_attackerteam'])
                        if team in [2,3]:
                            red = 255 if team == 2 else 0
                            green = 0
                            blue = 255 if team == 3 else 0
                    elif beam_user == 2:
                        red = random.randint(1,255)
                        green = random.randint(1,255)
                        blue = random.randint(1,255)
                    elif beam_user == 3:
                        red = int(dict_vs[vs_user]['red'])
                        green = int(dict_vs[vs_user]['green'])
                        blue = int(dict_vs[vs_user]['blue'])
                    if tools_version >= '0.417' or tools_version in ['0.416d','0.416e']:
                        es.server.queuecmd('est_effect 3 %s 0 %s %s %s %s %s %s %s %s %s %s %s %s %s 255'%(user, beam_vmt, atta_x, atta_y, atta_z + 45, user_x, user_y, user_z, beam_time, beam_width, beam_width, red, green, blue))
                    else:
                        es.server.queuecmd('est_effect 3 %s 0 %s %s %s %s %s %s %s %s %s %s %s %s 255'%(user, atta_x, atta_y, atta_z + 45, user_x, user_y, user_z, time, width, width, red, green, blue))
        user_location = vecmath.vector(es.getplayerlocation(user))
        attacker_location = vecmath.vector(es.getplayerlocation(attacker))
        distance = vecmath.distance(user_location, attacker_location)
        distance = distance * 0.0375
        distance_m = distance * 0.3408
        distance = '%0.2f'%distance
        distance_m = '%0.2f'%distance_m
        if stats_dist == 1:
            dist_show = str('%sft'%(distance))
        elif stats_dist == 2:
            dist_show = str('%sm'%(distance_m))
        elif stats_dist == 3:
            dist_show = str('%sm (%sft)'%(distance_m, distance))
        if ev['es_attackersteamid'] != 'BOT' and ev['es_userteam'] != ev['es_attackerteam'] and ev['es_attackerteam'] in ('2','3'):
            dict_stats[vs_attacker][vs_user]["distance"] = dist_show
            dict_stats[vs_attacker][vs_user]["weapon"] = weapon
            dict_stats[vs_attacker][vs_user]["killed"] = 'Killed' if headshot == 0 else 'Killed HS'
        if ev['es_steamid'] != 'BOT' and stats_ison == 1:
            if dict_vs[vs_user]['stats'] in [1,2]:
                text_vic(vs_user, user)
                text_wnd(vs_user, user)
                text_kill(vs_user, user)
                if ev['es_steamid'] == ev['es_attackersteamid']:
                    killer_msg = ('#defaultYou#green killed#default yourself')
                elif ev['es_steamid'] != ev['es_attackersteamid'] and ev['es_userteam'] == ev['es_attackerteam']:
                    killer_msg = ('#defaultYou were#green Team-Killed#default by#lightgreen%s'%(attackername))
                else:
                    if weapon == 'hegrenade' and playerlib.getPlayer(attacker).get('isdead') == 1:
                        killer_msg = ('%sKiller#default %s#green %s#default @ %s is already dead'%(color_killer, attackername, weapon, dist_show))
                    else:
                        killer_msg = ('%sKiller#default %s#green %s#default @ %s still has %s hp left'%(color_killer, attackername, weapon, dist_show, health))
                if colormsglib > '0':
                    ColorMsg(killer_msg).tell(user)
                else:
                    es.tell(user, '#multi', '%s'%(killer_msg))
            elif dict_vs[vs_user]['stats'] == 3:
                main_popup = popuplib.create(vs_user)
                vic_user = '%svic'%(vs_user)
                wnd_user = '%swnd'%(vs_user)
                kil_user = '%skil'%(vs_user)
                vic_popup = popuplib.create('%s'%(vic_user))
                wnd_popup = popuplib.create('%s'%(wnd_user))
                kil_popup = popuplib.create('%s'%(kil_user))
                space = " "
                main_popup.addline('%s'%('->1. You had no attackers that round'))
                main_popup.addline('%s'%(space))
                main_popup.addline('%s'%('->2. You did not wound anyone that round'))
                main_popup.addline('%s'%(space))
                main_popup.addline('%s'%('->3. You had no kills that round'))
                main_popup.addline('%s'%(space))
                vic_popup.addline('%s'%('->1. You had no attackers that round'))
                wnd_popup.addline('%s'%('->2. You did not wound anyone that round'))
                kil_popup.addline('%s'%('->3. You had no kills that round'))
                list_vic(main_popup, vic_popup, vs_user, user)
                list_wnd(main_popup, wnd_popup, vs_user, user)
                list_kil(main_popup, kil_popup, vs_user, user)
                vic_popup.addline('%s'%(space))
                wnd_popup.addline('%s'%(space))
                kil_popup.addline('%s'%(space))
                main_popup.addline('%s'%(space))
                if ev['es_steamid'] == ev['es_attackersteamid']:
                    killer_pop = ('You just killed Yourself!!!')
                elif ev['es_steamid'] != ev['es_attackersteamid'] and ev['es_userteam'] == ev['es_attackerteam']:
                    killer_pop = ('You were Team-Killed by %s'%(attackername))
                else:
                    if weapon == 'hegrenade' and playerlib.getPlayer(attacker).get('isdead') == 1:
                        killer_pop = ('%s %s %s @ %s is already dead'%(killer, attackername, weapon, dist_show))
                    else:
                        killer_pop = ('%s %s %s @ %s still has %s hp left'%(killer, attackername, weapon, dist_show, health))
                vic_popup.addline('%s'%(killer_pop))
                wnd_popup.addline('%s'%(killer_pop))
                kil_popup.addline('%s'%(killer_pop))
                main_popup.addline('%s'%(killer_pop))
                vic_popup.addline('%s'%(space))
                vic_popup.addline('%s'%('->2. Wounded'))
                vic_popup.addline('%s'%('->3. Killed'))
                vic_popup.addline('%s'%('->4. Main'))
                wnd_popup.addline('%s'%(space))
                wnd_popup.addline('%s'%('->1. Attackers'))
                wnd_popup.addline('%s'%('->3. Killed'))
                wnd_popup.addline('%s'%('->4. Main'))
                kil_popup.addline('%s'%(space))
                kil_popup.addline('%s'%('->1. Attackers'))
                kil_popup.addline('%s'%('->2. Wounded'))
                kil_popup.addline('%s'%('->4. Main'))
                main_popup.submenu(1, vic_popup)
                vic_popup.submenu(1, vic_popup)
                wnd_popup.submenu(1, vic_popup)
                kil_popup.submenu(1, vic_popup)
                main_popup.submenu(2, wnd_popup)
                vic_popup.submenu(2, wnd_popup)
                wnd_popup.submenu(2, wnd_popup)
                kil_popup.submenu(2, wnd_popup)
                main_popup.submenu(3, kil_popup)
                vic_popup.submenu(3, kil_popup)
                wnd_popup.submenu(3, kil_popup)
                kil_popup.submenu(3, kil_popup)
                main_popup.submenu(4, main_popup)
                vic_popup.submenu(4, main_popup)
                wnd_popup.submenu(4, main_popup)
                kil_popup.submenu(4, main_popup)
                vic_popup.timeout("view", timeout_death)
                wnd_popup.timeout("view", timeout_death)
                kil_popup.timeout("view", timeout_death)
                main_popup.timeout("view", timeout_death)
                main_popup.send(user)
            elif dict_vs[vs_user]['stats'] == 4:
                counter = 0
                user_popup = popuplib.create(vs_user)
                gui_vic(user_popup, vs_user, user)
                gui_wnd(user_popup, vs_user, user)
                gui_kill(user_popup, vs_user, user)
                counter += 1
                user_popup.addline('->%s. Killer'%(counter))
                if ev['es_steamid'] == ev['es_attackersteamid']:
                    killer_pop = ('    You just killed Yourself!!!')
                elif ev['es_steamid'] != ev['es_attackersteamid'] and ev['es_userteam'] == ev['es_attackerteam']:
                    killer_pop = ('    You were Team-Killed by %s'%(attackername))
                else:
                    if weapon == 'hegrenade' and playerlib.getPlayer(attacker).get('isdead') == 1:
                        killer_pop = ('    Killer %s %s @ %s is already dead'%(attackername, weapon, dist_show))
                    else:
                        killer_pop = ('    Killer %s %s @ %s still has %s hp left'%(attackername, weapon, dist_show, health))
                user_popup.addline('%s'%(killer_pop))
                user_popup.timeout("view", timeout_death)
                user_popup.send(user)

def round_end(ev):
    global dict_vs, dict_dest, dest_ison, stats_ison, use_round_end, dict_stats
    if use_round_end == 1:
        use_round_end = 0
        if dest_ison == 1:
            dest_damage = sorted(dict_dest, key=lambda x: dict_dest[x]['damage'], reverse=True)
            da_name = dict_dest[dest_damage[0]]['name']
            da_damage = dict_dest[dest_damage[0]]['damage']
            dest_kills = sorted(dest_damage, key=lambda x: dict_dest[x]['kills'], reverse=True)
            ki_name = dict_dest[dest_kills[0]]['name']
            ki_damage = dict_dest[dest_kills[0]]['damage']
            ki_kills = dict_dest[dest_kills[0]]['kills']
            for userid in playerlib.getPlayerList('#human'):
                user = int(userid)
                vs_user = playerlib.uniqueid(user, True)
                if dict_vs[vs_user]['dest'] in [1,5]:
                    most_dest = ('Most Destructive:\n %s with %s kills\n and %s total damage'%(ki_name, ki_kills, ki_damage))
                    usermsg.hudhint(user, '%s'%(most_dest))
                if dict_vs[vs_user]['dest'] in [2,6]:
                    most_dest = ('Most Destructive:\n %s with %s total damage'%(da_name, da_damage))
                    usermsg.hudhint(user, '%s'%(most_dest))
                if dict_vs[vs_user]['dest'] in [3,5]:
                    most_dest = ('Most Destructive: %s with %s kills and %s total damage'%(ki_name, ki_kills, ki_damage))
                    usermsg.centermsg(user, '%s'%(most_dest))
                    gamethread.delayed(1, usermsg.centermsg, (user, '%s'%(most_dest)))
                    gamethread.delayed(2, usermsg.centermsg, (user, '%s'%(most_dest)))
                if dict_vs[vs_user]['dest'] in [4,6]:
                    most_dest = ('Most Destructive: %s with %s total damage'%(da_name, da_damage))
                    usermsg.centermsg(user, '%s'%(most_dest))
                    gamethread.delayed(1, usermsg.centermsg, (user, '%s'%(most_dest)))
                    gamethread.delayed(2, usermsg.centermsg, (user, '%s'%(most_dest)))
        if stats_ison == 1:
            for userid in playerlib.getPlayerList('#alive,#human'):
                user = int(userid)
                vs_user = playerlib.uniqueid(user, True)
                if dict_vs[vs_user]['stats'] in [1,2]:
                    text_vic(vs_user, user)
                    text_wnd(vs_user, user)
                    text_kill(vs_user, user)
                elif dict_vs[vs_user]['stats'] == 3:
                    main_popup = popuplib.create(vs_user)
                    vic_user = '%svic'%(vs_user)
                    wnd_user = '%swnd'%(vs_user)
                    kil_user = '%skil'%(vs_user)
                    vic_popup = popuplib.create('%s'%(vic_user))
                    wnd_popup = popuplib.create('%s'%(wnd_user))
                    kil_popup = popuplib.create('%s'%(kil_user))
                    vic_list = '->1. You had no attackers that round'
                    wnd_list = '->2. You did not wound anyone that round'
                    kil_list = '->3. You had no kills that round'
                    space = " "
                    main_popup.addline('%s'%(vic_list))
                    main_popup.addline('%s'%(space))
                    main_popup.addline('%s'%(wnd_list))
                    main_popup.addline('%s'%(space))
                    main_popup.addline('%s'%(kil_list))
                    main_popup.addline('%s'%(space))
                    vic_popup.addline('%s'%(vic_list))
                    wnd_popup.addline('%s'%(wnd_list))
                    kil_popup.addline('%s'%(kil_list))
                    list_vic(main_popup, vic_popup, vs_user, user)
                    list_wnd(main_popup, wnd_popup, vs_user, user)
                    list_kil(main_popup, kil_popup, vs_user, user)
                    vic_popup.addline('%s'%(space))
                    vic_popup.addline('%s'%('->2. Wounded'))
                    vic_popup.addline('%s'%('->3. Killed'))
                    vic_popup.addline('%s'%('->4. Main'))
                    wnd_popup.addline('%s'%(space))
                    wnd_popup.addline('%s'%('->1. Attackers'))
                    wnd_popup.addline('%s'%('->3. Killed'))
                    wnd_popup.addline('%s'%('->4. Main'))
                    kil_popup.addline('%s'%(space))
                    kil_popup.addline('%s'%('->1. Attackers'))
                    kil_popup.addline('%s'%('->2. Wounded'))
                    kil_popup.addline('%s'%('->4. Main'))
                    main_popup.submenu(1, vic_popup)
                    vic_popup.submenu(1, vic_popup)
                    wnd_popup.submenu(1, vic_popup)
                    kil_popup.submenu(1, vic_popup)
                    main_popup.submenu(2, wnd_popup)
                    vic_popup.submenu(2, wnd_popup)
                    wnd_popup.submenu(2, wnd_popup)
                    kil_popup.submenu(2, wnd_popup)
                    main_popup.submenu(3, kil_popup)
                    vic_popup.submenu(3, kil_popup)
                    wnd_popup.submenu(3, kil_popup)
                    kil_popup.submenu(3, kil_popup)
                    main_popup.submenu(4, main_popup)
                    vic_popup.submenu(4, main_popup)
                    wnd_popup.submenu(4, main_popup)
                    kil_popup.submenu(4, main_popup)
                    vic_popup.timeout("view", timeout_round)
                    wnd_popup.timeout("view", timeout_round)
                    kil_popup.timeout("view", timeout_round)
                    main_popup.timeout("view", timeout_round)
                    main_popup.send(user)
                elif dict_vs[vs_user]['stats'] == 4:
                    counter = 0
                    user_popup = popuplib.create(vs_user)
                    gui_vic(user_popup, vs_user, user)
                    gui_wnd(user_popup, vs_user, user)
                    gui_kill(user_popup, vs_user, user)
                    user_popup.timeout("view", timeout_round)
                    user_popup.send(user)

def text_vic(vs_user, user):
    global dict_stats
    stats = int(dict_vs[vs_user]['stats'])
    for vs_var in dict_stats[vs_user]:
        vs_key = str(vs_var)
        damage = dict_stats[vs_user][vs_key]["victim"]
        if damage > 0:
            name = dict_stats[vs_user][vs_key]["oppname"]
            hits = dict_stats[vs_user][vs_key]["vichits"]
            typehit = 'hit' if hits == 1 else 'hits'
            vic_message = ('%sAttacker#default %s %s dmg %s %s'%(color_attacker, name, damage, hits, typehit))
            if stats == 1:
                groups = 0
                for x in range(1,8):
                    hitgroup = vic_hitgroup[x]
                    grouphits = dict_stats[vs_user][vs_key][hitgroup]
                    if grouphits > 0:
                        group_text = hitgroups[x]
                        if groups == 0:
                            vic_message = ('%s - %s: %s'%(vic_message, group_text, grouphits))
                            groups = 1
                        else:
                            vic_message = ('%s; %s: %s'%(vic_message, group_text, grouphits))
            if colormsglib > '0':
                ColorMsg(vic_message).tell(user)
            else:
                es.tell(user, '#multi', '%s'%(vic_message))

def text_wnd(vs_user, user):
    global dict_stats
    stats = int(dict_vs[vs_user]['stats'])
    for vs_var in dict_stats[vs_user]:
        vs_key = str(vs_var)
        damage = dict_stats[vs_user][vs_key]["wounded"]
        if damage > 0:
            kill = dict_stats[vs_user][vs_key]["killed"]
            if kill == 0:
                name = dict_stats[vs_user][vs_key]["oppname"]
                hits = dict_stats[vs_user][vs_key]["wndhits"]
                typehit = 'hit' if hits == 1 else 'hits'
                wnd_message = ('%sWounded#default %s %s dmg %s %s'%(color_wounded, name, damage, hits, typehit))
                if stats == 1:
                    groups = 0
                    for x in range(1,8):
                        hitgroup = wnd_hitgroup[x]
                        grouphits = dict_stats[vs_user][vs_key][hitgroup]
                        if grouphits > 0:
                            group_text = hitgroups[x]
                            if groups == 0:
                                wnd_message = ('%s - %s: %s'%(wnd_message, group_text, grouphits))
                                groups = 1
                            else:
                                wnd_message = ('%s; %s: %s'%(wnd_message, group_text, grouphits))
                if colormsglib > '0':
                    ColorMsg(wnd_message).tell(user)
                else:
                    es.tell(user, '#multi', '%s'%(wnd_message))
                
def text_kill(vs_user, user):
    global dict_stats
    stats = int(dict_vs[vs_user]['stats'])
    for vs_var in dict_stats[vs_user]:
        vs_key = str(vs_var)
        damage = dict_stats[vs_user][vs_key]["wounded"]
        if damage > 0:
            kill = dict_stats[vs_user][vs_key]["killed"]
            if kill > 0:
                name = dict_stats[vs_user][vs_key]["oppname"]
                hits = dict_stats[vs_user][vs_key]["wndhits"]
                dist_show = str(dict_stats[vs_user][vs_key]["distance"])
                weapon = dict_stats[vs_user][vs_key]["weapon"]
                typehit = 'hit' if hits == 1 else 'hits'
                kil_message = ('%s%s#default %s %s dmg %s %s#green %s#default @ %s'%(color_killed, kill, name, damage, hits, typehit, weapon, dist_show))
                if stats == 1:
                    groups = 0
                    for x in range(1,8):
                        hitgroup = wnd_hitgroup[x]
                        grouphits = dict_stats[vs_user][vs_key][hitgroup]
                        if grouphits > 0:
                            group_text = hitgroups[x]
                            if groups == 0:
                                kil_message = ('%s - %s: %s'%(kil_message, group_text, grouphits))
                                groups = 1
                            else:
                                kil_message = ('%s; %s: %s'%(kil_message, group_text, grouphits))
                if colormsglib > '0':
                    ColorMsg(kil_message).tell(user)
                else:
                    es.tell(user, '#multi', '%s'%(kil_message))

def list_vic(main_popup, vic_popup, vs_user, user):
    global dict_stats
    enemies = 0
    enemdmg = 0
    enemhits = 0
    for vs_var in dict_stats[vs_user]:
        vs_key = str(vs_var)
        damage = dict_stats[vs_user][vs_key]["victim"]
        if damage > 0:
            enemies += 1
            enemdmg += damage
            name = dict_stats[vs_user][vs_key]["oppname"]
            hits = dict_stats[vs_user][vs_key]["vichits"]
            enemhits += hits
            typehit = 'hit' if hits == 1 else 'hits'
            vic_list = ('    %s %s dmg %s %s'%(name, damage, hits, typehit))
            groups = 0
            for x in range(1,8):
                hitgroup = vic_hitgroup[x]
                grouphits = dict_stats[vs_user][vs_key][hitgroup]
                if grouphits > 0:
                    group_text = hitgroups[x]
                    if groups == 0:
                        vic_list = ('%s - %s: %s'%(vic_list, group_text, grouphits))
                        groups = 1
                    else:
                        vic_list = ('%s; %s: %s'%(vic_list, group_text, grouphits))
            vic_popup.addline('%s'%(vic_list))
    if enemies > 0:
        attack = 'attacker' if enemies == 1 else 'attackers'
        typehit = 'hit' if enemhits == 1 else 'hits'
        totalvic = ('->1. You had %s %s for %s dmg in %s %s'%(enemies, attack, enemdmg, enemhits, typehit))
        vic_popup.modline(1, '%s'%(totalvic))
        main_popup.modline(1, '%s'%(totalvic))

def list_wnd(main_popup, wnd_popup, vs_user, user):
    global dict_stats
    enemies = 0
    enemdmg = 0
    enemhits = 0
    for vs_var in dict_stats[vs_user]:
        vs_key = str(vs_var)
        damage = dict_stats[vs_user][vs_key]["wounded"]
        if damage > 0:
            kill = dict_stats[vs_user][vs_key]["killed"]
            if kill == 0:
                enemies += 1
                enemdmg += damage
                name = dict_stats[vs_user][vs_key]["oppname"]
                hits = dict_stats[vs_user][vs_key]["wndhits"]
                enemhits += hits
                typehit = 'hit' if hits == 1 else 'hits'
                wnd_list = ('    %s %s dmg %s %s'%(name, damage, hits, typehit))
                groups = 0
                for x in range(1,8):
                    hitgroup = wnd_hitgroup[x]
                    grouphits = dict_stats[vs_user][vs_key][hitgroup]
                    if grouphits > 0:
                        group_text = hitgroups[x]
                        if groups == 0:
                            wnd_list = ('%s - %s: %s'%(wnd_list, group_text, grouphits))
                            groups = 1
                        else:
                            wnd_list = ('%s; %s: %s'%(wnd_list, group_text, grouphits))
                wnd_popup.addline('%s'%(wnd_list))
    if enemies > 0:
        wound = 'enemy' if enemies == 1 else 'enemies'
        typehit = 'hit' if enemhits == 1 else 'hits'
        totalwnd = ('->2. You wounded %s %s for %s dmg in %s %s'%(enemies, wound, enemdmg, enemhits, typehit))
        wnd_popup.modline(1, '%s'%(totalwnd))
        main_popup.modline(3, '%s'%(totalwnd))

def list_kil(main_popup, kil_popup, vs_user, user):
    global dict_stats
    enemies = 0
    enemdmg = 0
    enemhits = 0
    for vs_var in dict_stats[vs_user]:
        vs_key = str(vs_var)
        damage = dict_stats[vs_user][vs_key]["wounded"]
        if damage > 0:
            kill = dict_stats[vs_user][vs_key]["killed"]
            if kill > 0:
                enemies += 1
                enemdmg += damage
                name = dict_stats[vs_user][vs_key]["oppname"]
                hits = dict_stats[vs_user][vs_key]["wndhits"]
                enemhits += hits
                typehit = 'hit' if hits == 1 else 'hits'
                weapon = dict_stats[vs_user][vs_key]["weapon"]
                dist_show = str(dict_stats[vs_user][vs_key]["distance"])
                kil_list = ('    %s %s dmg %s %s %s @ %s'%(name, damage, hits, typehit, weapon, dist_show))
                groups = 0
                for x in range(1,8):
                    hitgroup = wnd_hitgroup[x]
                    grouphits = dict_stats[vs_user][vs_key][hitgroup]
                    if grouphits > 0:
                        group_text = hitgroups[x]
                        if groups == 0:
                            kil_list = ('%s - %s: %s'%(kil_list, group_text, grouphits))
                            groups = 1
                        else:
                            kil_list = ('%s; %s: %s'%(kil_list, group_text, grouphits))
                kil_popup.addline('%s'%(kil_list))
    if enemies > 0:
        kill = 'enemy' if enemies == 1 else 'enemies'
        typehit = 'hit' if enemhits == 1 else 'hits'
        totalkil = ('->3. You killed %s %s with %s dmg in %s %s'%(enemies, kill, enemdmg, enemhits, typehit))
        kil_popup.modline(1, '%s'%(totalkil))
        main_popup.modline(5, '%s'%(totalkil))

def gui_vic(user_popup, vs_user, user):
    global counter, dict_stats
    attackers = 0
    for vs_var in dict_stats[vs_user]:
        vs_key = str(vs_var)
        damage = dict_stats[vs_user][vs_key]["victim"]
        if damage > 0:
            if attackers == 0:
                counter += 1
                attackers = 1
                user_popup.addline('->%s. Attackers'%(counter))
            name = dict_stats[vs_user][vs_key]["oppname"]
            hits = dict_stats[vs_user][vs_key]["vichits"]
            typehit = 'hit' if hits == 1 else 'hits'
            vic_gui = ('    %s %s dmg %s %s'%(name, damage, hits, typehit))
            user_popup.addline('%s'%(vic_gui))

def gui_wnd(user_popup, vs_user, user):
    global counter, dict_stats
    wounded = 0
    for vs_var in dict_stats[vs_user]:
        vs_key = str(vs_var)
        damage = dict_stats[vs_user][vs_key]["wounded"]
        if damage > 0:
            kill = dict_stats[vs_user][vs_key]["killed"]
            if kill == 0:
                if wounded == 0:
                    counter += 1
                    wounded = 1
                    user_popup.addline('->%s. Wounded'%(counter))
                name = dict_stats[vs_user][vs_key]["oppname"]
                hits = dict_stats[vs_user][vs_key]["wndhits"]
                typehit = 'hit' if hits == 1 else 'hits'
                wnd_gui = ('    %s %s dmg %s %s'%(name, damage, hits, typehit))
                user_popup.addline('%s'%(wnd_gui))

def gui_kill(user_popup, vs_user, user):
    global counter, dict_stats
    kil_check = 0
    for vs_var in dict_stats[vs_user]:
        vs_key = str(vs_var)
        damage = dict_stats[vs_user][vs_key]["wounded"]
        if damage > 0:
            kill = dict_stats[vs_user][vs_key]["killed"]
            if kill > 0:
                if kil_check == 0:
                    counter += 1
                    kil_check = 1
                    user_popup.addline('->%s. Killed'%(counter))
                name = dict_stats[vs_user][vs_key]["oppname"]
                hits = dict_stats[vs_user][vs_key]["wndhits"]
                typehit = 'hit' if hits == 1 else 'hits'
                kil_gui = ('    %s %s dmg %s %s'%(name, damage, hits, typehit))
                user_popup.addline('%s'%(kil_gui))

def player_say(ev):
    global dict_vs, anno_text, stats_ison, dest_ison, beam_ison
    text = ev['text']
    userid = ev['userid']
    vs_user = playerlib.uniqueid(userid, True)
    if text == anno_text:
        vs_mainmenu = popuplib.easymenu('vs_mainmenu', 'vs_mainmenu_choice', mainmenu)
        vs_mainmenu.settitle("Victim Stats Options")
        if stats_ison == 1:
            player_stats = int(dict_vs[vs_user]['stats'])
            main_stats = vs_stats[player_stats]
            vs_mainmenu.addoption('stats', 'Stats Display Options [%s]'%(main_stats))
        if dest_ison == 1:
            player_dest = int(dict_vs[vs_user]['dest'])
            main_dest = vs_dest[player_dest]
            vs_mainmenu.addoption('dest', 'Most Destructive Options [%s]'%(main_dest))
        if beam_ison == 1 and tools_version >= '0.414':
            player_beam = int(dict_vs[vs_user]['beam'])
            main_beam = vs_beam[player_beam]
            vs_mainmenu.addoption('beam', 'Death Beam Options [%s]'%(main_beam))
        popuplib.send('vs_mainmenu', userid)
        
def mainmenu(userid, choice, popupid):
    global red_val, green_val, blue_val
    vs_user = playerlib.uniqueid(userid, True)
    if choice == 'stats':
        vs_statsmenu = popuplib.easymenu('vs_statsmenu', 'vs_stats_choice', statsmenu)
        player_stats = int(dict_vs[vs_user]['stats'])
        main_stats = vs_stats[player_stats]
        vs_statsmenu.settitle("Stats Display Options [%s]"%(main_stats))
        for key in vs_stats:
            option = vs_stats[key]
            vs_statsmenu.addoption(key, option)
        popuplib.send('vs_statsmenu', userid)
    elif choice == 'dest':
        vs_destmenu = popuplib.easymenu('vs_destmenu', 'vs_dest_choice', destmenu)
        player_dest = int(dict_vs[vs_user]['dest'])
        main_dest = vs_dest[player_dest]
        vs_destmenu.settitle("Most Destructive Options [%s]"%(main_dest))
        for key in vs_dest:
            option = vs_dest[key]
            vs_destmenu.addoption(key, option)
        popuplib.send('vs_destmenu', userid)
    elif choice == 'beam':
        red_val = int(dict_vs[vs_user]['red'])
        green_val = int(dict_vs[vs_user]['green'])
        blue_val = int(dict_vs[vs_user]['blue'])
        vs_beammenu = popuplib.easymenu('vs_beammenu', 'vs_beam_choice', beammenu)
        player_beam = int(dict_vs[vs_user]['beam'])
        main_beam = vs_beam[player_beam]
        vs_beammenu.settitle("Death Beam Options [%s]"%(main_beam))
        for key in vs_beam:
            option = vs_beam[key]
            vs_beammenu.addoption(key, option)
        popuplib.send('vs_beammenu', userid)
            
def statsmenu(userid, choice, popupid):
    global dict_vs
    vs_user = playerlib.uniqueid(userid, True)
    user_stats = int(dict_vs[vs_user]['stats'])
    if user_stats != choice:
        dict_vs[vs_user]['stats'] = int(choice)
        stats_type = vs_stats[choice]
        es.tell(userid, '#multi', '#green[Victim Stats]#default Stats Display changed to#lightgreen %s'%(stats_type))
        save_users()

def destmenu(userid, choice, popupid):
    global dict_vs
    vs_user = playerlib.uniqueid(userid, True)
    user_dest = int(dict_vs[vs_user]['dest'])
    if user_dest != choice:
        dict_vs[vs_user]['dest'] = int(choice)
        dest_type = vs_dest[choice]
        es.tell(userid, '#multi', '#green[Victim Stats]#default Most Destructive changed to#lightgreen %s'%(dest_type))
        save_users()

def beammenu(userid, choice, popupid):
    global dict_vs, red_val, green_val, blue_val
    vs_user = playerlib.uniqueid(userid, True)
    if choice == 3:
        red_val = int(dict_vs[vs_user]['red'])
        green_val = int(dict_vs[vs_user]['green'])
        blue_val = int(dict_vs[vs_user]['blue'])
        createcolormenu(userid)
    else:
        beam_user = int(dict_vs[vs_user]['beam'])
        if beam_user != choice:
            beam_type = vs_beam[choice]
            dict_vs[vs_user]['beam'] = int(choice)
            es.tell(userid, '#multi', '#green[Victim Stats]#default Death Beam changed to#lightgreen %s'%(beam_type))
            save_users()

def createcolormenu(userid):
    global red_val, green_val, blue_val
    if popuplib.exists('vs_colormenu'):
        popuplib.delete('vs_colormenu')
    vs_colormenu = popuplib.easymenu('vs_colormenu', 'vs_colormenu_choice', choosecolor)
    vs_colormenu.settitle("Change a Color's Value:")
    vs_colormenu.addoption(1,'Red %s'%(red_val))
    vs_colormenu.addoption(2,'Green %s'%(green_val))
    vs_colormenu.addoption(3,'Blue %s'%(blue_val))
    vs_colormenu.addoption(4,'Save and Exit')
    popuplib.send('vs_colormenu', userid)

def choosecolor(userid, choice, popupid):
    global dict_vs, color_val, red_val, green_val, blue_val
    vs_user = playerlib.uniqueid(userid, True)
    if choice in [1,2,3]:
        if choice == 1:
            color_val = red_val
            redmenu = popuplib.easymenu('redmenu', 'redmenu_choice', changered)
            redmenu.settitle('Change Red Value: %s'%(color_val))
            for x in color_range:
                addsub = color_range[x]
                redmenu.addoption(x, addsub)
            popuplib.send('redmenu', userid)
        elif choice == 2:
            color_val = green_val
            greenmenu = popuplib.easymenu('greenmenu', 'greenmenu_choice', changegreen)
            greenmenu.settitle('Change Green Value: %s'%(color_val))
            for x in color_range:
                addsub = color_range[x]
                greenmenu.addoption(x, addsub)
            popuplib.send('greenmenu', userid)
        elif choice == 3:
            color_val = blue_val
            bluemenu = popuplib.easymenu('bluemenu', 'bluemenu_choice', changeblue)
            bluemenu.settitle('Change Blue Value: %s'%(color_val))
            for x in color_range:
                addsub = color_range[x]
                bluemenu.addoption(x, addsub)
            popuplib.send('bluemenu', userid)
    else:
        dict_vs[vs_user]['red'] = red_val
        dict_vs[vs_user]['green'] = green_val
        dict_vs[vs_user]['blue'] = blue_val
        dict_vs[vs_user]['beam'] = 3
        es.tell(userid, '#multi', '#green[Victim Stats]#default Death Beam changed to#lightgreen Set Color: Red %s; Green %s; Blue %s'%(red_val, green_val, blue_val))
        save_users()
        
def valuecheck():
    global color_val
    if color_val > 255:
        color_val = 255
    if color_val < 0:
        color_val = 0

def changered(userid, choice, popupid):
    global color_val, red_val
    if choice in range(1,7):
        addchoice = vs_range[choice]
        if choice in [1,3,5]:
            color_val += addchoice
        else:
            color_val -= addchoice
        valuecheck()
        redmenu = popuplib.easymenu('redmenu', 'redmenu_choice', changered)
        redmenu.settitle('Change Red Value: %s'%(color_val))
        for x in color_range:
            addsub = color_range[x]
            redmenu.addoption(x, addsub)
        popuplib.send('redmenu', userid)
    else:
        red_val = color_val
        createcolormenu(userid)
    
def changegreen(userid, choice, popupid):
    global color_val, green_val
    if choice in range(1,7):
        addchoice = vs_range[choice]
        if choice in [1,3,5]:
            color_val += addchoice
        else:
            color_val -= addchoice
        valuecheck()
        greenmenu = popuplib.easymenu('greenmenu', 'greenmenu_choice', changegreen)
        greenmenu.settitle('Change Green Value: %s'%(color_val))
        for x in color_range:
            addsub = color_range[x]
            greenmenu.addoption(x, addsub)
        popuplib.send('greenmenu', userid)
    else:
        green_val = color_val
        createcolormenu(userid)
    
def changeblue(userid, choice, popupid):
    global color_val, blue_val
    if choice in range(1,7):
        addchoice = vs_range[choice]
        if choice in [1,3,5]:
            color_val += addchoice
        else:
            color_val -= addchoice
        valuecheck()
        bluemenu = popuplib.easymenu('bluemenu', 'bluemenu_choice', changeblue)
        bluemenu.settitle('Change Blue Value: %s'%(color_val))
        for x in color_range:
            addsub = color_range[x]
            bluemenu.addoption(x, addsub)
        popuplib.send('bluemenu', userid)
    else:
        blue_val = color_val
        createcolormenu(userid)
    
def player_disconnect(ev):
    save_users()

def save_users():
    file_users = open(es.getAddonPath('victim_stats') + '/user_data.db', 'w')
    pickle.dump(dict_vs, file_users)
    file_users.close()

def unload():
    es.dbgmsg(0,"[Victim Stats] Unloading Victim Stats")
    save_users()
    